<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/torch_modules/parallelism/data_parallel.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>data_parallel.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../../settings.html"><img src="../../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">environment</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">torch_modules</span>::<span class="ident">analysis</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">torch_modules</span>::<span class="ident">model</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">collections</span>::<span class="ident">BTreeSet</span>;

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">all_reduce_time</span>(<span class="ident">d</span>: <span class="kw-2">&amp;</span><span class="ident">device</span>::<span class="ident">Devices</span>, <span class="ident">gids</span>: <span class="kw-2">&amp;</span><span class="ident">BTreeSet</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>, <span class="ident">size</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
    <span class="kw">let</span> <span class="ident">b_cross</span> <span class="op">=</span> <span class="ident">d</span>.<span class="ident">is_cross_machine_within</span>(<span class="ident">gids</span>);
    <span class="kw">let</span> <span class="ident">f_factor</span>: <span class="ident">f64</span> <span class="op">=</span> (<span class="ident">gids</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="number">1</span>) <span class="kw">as</span> <span class="ident">f64</span> <span class="op">/</span> <span class="ident">gids</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">f64</span>;
    <span class="kw">match</span> <span class="ident">gids</span>.<span class="ident">len</span>() {
        <span class="number">1</span> <span class="op">=</span><span class="op">&gt;</span> <span class="number">0.0</span>,
        <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="kw">match</span> <span class="ident">b_cross</span> {
            <span class="bool-val">true</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">size</span> <span class="op">*</span> <span class="number">2.0</span> <span class="op">*</span> <span class="ident">f_factor</span> <span class="op">/</span> <span class="ident">ethernet</span>::<span class="ident">BANDWIDTH_ETHERNET_NCCL</span>,
            <span class="bool-val">false</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">size</span> <span class="op">*</span> <span class="number">2.0</span> <span class="op">*</span> <span class="ident">f_factor</span> <span class="op">/</span> <span class="ident">nvlink</span>::<span class="ident">BANDWIDTH_NVLINK_P2P</span> <span class="op">/</span> (<span class="ident">gids</span>.<span class="ident">len</span>() <span class="op">/</span> <span class="number">2</span>) <span class="kw">as</span> <span class="ident">f64</span>,
        },
    }
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dp_speedup</span>(<span class="ident">d</span>: <span class="kw-2">&amp;</span><span class="ident">device</span>::<span class="ident">Devices</span>, <span class="ident">m</span>: <span class="kw-2">&amp;</span><span class="ident">model</span>::<span class="ident">Model</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
    <span class="kw">let</span> <span class="ident">comp_time</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">perf</span>.<span class="ident">compute_times</span>[<span class="number">0</span>][<span class="ident">m</span>.<span class="ident">perf</span>.<span class="ident">compute_times</span>[<span class="number">0</span>].<span class="ident">len</span>() <span class="op">-</span> <span class="number">1</span>];
    <span class="kw">let</span> <span class="ident">param_size</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">perf</span>.<span class="ident">parameter_sizes</span>[<span class="number">0</span>][<span class="ident">m</span>.<span class="ident">perf</span>.<span class="ident">parameter_sizes</span>[<span class="number">0</span>].<span class="ident">len</span>() <span class="op">-</span> <span class="number">1</span>];
    <span class="kw">let</span> <span class="ident">all_gids</span> <span class="op">=</span> <span class="ident">d</span>.<span class="ident">all_gpus</span>();
    <span class="kw">let</span> <span class="ident">comm_time</span> <span class="op">=</span> <span class="ident">all_reduce_time</span>(<span class="ident">d</span>, <span class="kw-2">&amp;</span><span class="ident">all_gids</span>, <span class="ident">param_size</span>);

    <span class="ident">comp_time</span> <span class="op">/</span> (<span class="ident">comp_time</span> <span class="op">/</span> <span class="ident">d</span>.<span class="ident">num_gpus</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">+</span> <span class="ident">comm_time</span>)
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dp_p3_speedup</span>(<span class="ident">d</span>: <span class="kw-2">&amp;</span><span class="ident">device</span>::<span class="ident">Devices</span>, <span class="ident">m</span>: <span class="kw-2">&amp;</span><span class="ident">model</span>::<span class="ident">Model</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
    <span class="kw">let</span> <span class="ident">comp_time</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">perf</span>.<span class="ident">compute_times</span>[<span class="number">0</span>][<span class="ident">m</span>.<span class="ident">perf</span>.<span class="ident">compute_times</span>[<span class="number">0</span>].<span class="ident">len</span>() <span class="op">-</span> <span class="number">1</span>];

    <span class="kw">let</span> <span class="ident">p3stats</span> <span class="op">=</span> <span class="ident">cc_overlap</span>::<span class="ident">p3</span>(<span class="ident">d</span>, <span class="ident">m</span>);
    <span class="ident">comp_time</span> <span class="op">/</span> (<span class="ident">comp_time</span> <span class="op">/</span> <span class="ident">d</span>.<span class="ident">num_gpus</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">+</span> <span class="ident">p3stats</span>.<span class="ident">offset</span>)
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dp_speedup_strong</span>(<span class="ident">d</span>: <span class="kw-2">&amp;</span><span class="ident">device</span>::<span class="ident">Devices</span>, <span class="ident">compute</span>: <span class="ident">f64</span>, <span class="ident">all_reduce</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
    <span class="ident">compute</span> <span class="op">/</span> (<span class="ident">compute</span> <span class="op">/</span> <span class="ident">d</span>.<span class="ident">num_gpus</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">+</span> <span class="ident">all_reduce</span>)
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">dp_speedup_weak</span>(<span class="ident">d</span>: <span class="kw-2">&amp;</span><span class="ident">device</span>::<span class="ident">Devices</span>, <span class="ident">compute</span>: <span class="ident">f64</span>, <span class="ident">all_reduce</span>: <span class="ident">f64</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">f64</span> {
    <span class="ident">d</span>.<span class="ident">num_gpus</span> <span class="kw">as</span> <span class="ident">f64</span> <span class="op">*</span> (<span class="ident">compute</span> <span class="op">/</span> (<span class="ident">compute</span> <span class="op">+</span> <span class="ident">all_reduce</span>))
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../../";window.currentCrate = "HPGO";</script><script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script><script defer src="../../../../search-index.js"></script></body></html>